Subject: Ftp-WG: FTP over SSL

From: Jeffrey Altman <[email-masked]>
Date: Tue, 7 Aug 2001 11:37:36 -0500

> At 09:56 AM 8/7/2001, you wrote:
> >The Data connection should be terminated.  The fact that the Data
> >channel has been interrupted does not imply in any way that the
> >security of the Control channel has been violated.
> 
> Could you clarify - does this mean that you think if a sender gracefully 
> closes the socket without first closing the TLS connection, the receiver 
> should treat this as a successful completion of the transfer?  Or not?

I was making no statement about the success of the transfer.  I was
commenting on whether or not the control channel connection should be
terminated in response to a failure to properly shutdown a data
channel.

I would argue that it is impossible to treat the data transfer as
successful without a proper shutdown. 

> > > I do agree that it might be nice to point out that TLS requires this
> > > behaviour and implementations could be considered broken if they don't
> > > send close_notifys.
> >
> >Although, unnecessary.
> 
> There's at least one implementation out there - specifically, CuteFTP, that 
> closes the socket without shutting down the TLS session on that 
> socket.  When I have time, I'll be getting onto them about this 
> behaviour.  However, it may be worth putting in a note as to whether it 
> really matters for the purposes of FTP as to whether the client shuts down 
> TLS properly, or just closes the socket gracefully underneath it.
> 
> There are two RFCs at question here that may not be adequately read in 
> depth - the first is venereal old RFC 959, with its concept of closing the 
> socket to indicate end of transfer in stream mode.  The second is whatever 
> TLS RFC says that a TLS shutdown must be performed prior to closure.  Now, 
> seriously, while you and I may have bothered to read through that RFC, how 
> many FTP app authors are going to do more than read the SDK documentation 
> for whatever SSL library they're using?

Every SSL library I know of states that a shutdown must be performed
prior to a socket close.  

 Jeffrey Altman * Sr.Software Designer      C-Kermit 8.0 Beta available
 The Kermit Project @ Columbia University   includes Secure Telnet and FTP
 http://www.kermit-project.org/             using Kerberos, SRP, and 
 [email-masked]          OpenSSL.  SSH soon to follow.